

package uranodai.chumbyas
{
	import flash.events.Event;
	import flash.events.EventDispatcher;
	
	import it.h_umus.osc.OSCArgument;
	import it.h_umus.osc.OSCConnection;
	import it.h_umus.osc.OSCConnectionEvent;
	import it.h_umus.osc.OSCMessage;
	import it.h_umus.osc.OSCPacket;
	
	import uranodai.chumbyas.event.ChumbyEvent;
	import uranodai.chumbyas.model.Accelerometer;
	import uranodai.chumbyas.model.Touch;

	public class Chumbyas extends EventDispatcher
	{
		private var connection:OSCConnection;

		public function Chumbyas()
		{
			connection=new OSCConnection();
			connection.addEventListener(Event.CONNECT, trace);
			connection.addEventListener(OSCConnectionEvent.OSC_PACKET_IN, onPacketIn);
		}

		public function connect(host:String="localhost", port:int=5000):void
		{
			connection.connect(host, port);
		}

		public function onPacketIn(e:OSCConnectionEvent):void
		{

			var p:OSCPacket=e.data;

			//trace(p, p.messages.length)
			
			for (var i:int=0; i < p.messages.length; i++)
			{
				var msg:OSCMessage=p.messages[i];
				
				if(msg.name == ChumbyEvent.UPDATE_TOUCH)
				{
					parseTouch(msg);
				}
				else if(msg.name == ChumbyEvent.UPDATE_ACCELEROMETER)
				{
					parseAccelerometer(msg);
				}
			}
		}
		
		private function parseTouch(msg:OSCMessage):void
		{
			if(msg.arguments.length!=2) return;
			
			var arg1:OSCArgument = msg.arguments[0];
			var arg2:OSCArgument = msg.arguments[1];
			
			//trace(this, "update touch", arg1.value, arg2.value);
			
			var e:ChumbyEvent = new ChumbyEvent(ChumbyEvent.UPDATE_TOUCH);
			e.touch = new Touch(Number(arg1.value), Number(arg2.value));
			dispatchEvent(e);
		}
		
		private function parseAccelerometer(msg:OSCMessage):void
		{
			if(msg.arguments.length!=13) return;
			
			var accelerometer:Accelerometer = new Accelerometer();
			accelerometer.version = Number(msg.arguments[0].value);
			accelerometer.timestamp = Number(msg.arguments[1].value);
			accelerometer.currentX = Number(msg.arguments[2].value);
			accelerometer.currentY = Number(msg.arguments[3].value);
			accelerometer.currentZ = Number(msg.arguments[4].value);
			accelerometer.avgX = Number(msg.arguments[5].value);
			accelerometer.avgY = Number(msg.arguments[6].value);
			accelerometer.avgZ = Number(msg.arguments[7].value);
			accelerometer.impactX = Number(msg.arguments[8].value);
			accelerometer.impactY = Number(msg.arguments[9].value);
			accelerometer.impactZ = Number(msg.arguments[10].value);
			accelerometer.impactTime = Number(msg.arguments[11].value);
			accelerometer.impactHints = Number(msg.arguments[12].value);
			accelerometer.calc();
			
			var e:ChumbyEvent = new ChumbyEvent(ChumbyEvent.UPDATE_ACCELEROMETER);
			e.accelerometer = accelerometer;
			dispatchEvent(e);
			
//			for(var i:int=0; i<msg.arguments.length; i++)
//			{
//				var arg:OSCArgument = msg.arguments[i];
//				trace(arg.value);
//			}
			
		}
		
		

	}
}