package uranodai.chumbyas.model
{

	public class Accelerometer
	{
		public var version:Number;
		public var timestamp:Number;
		public var currentX:Number;
		public var currentY:Number;
		public var currentZ:Number;
		public var avgX:Number;
		public var avgY:Number;
		public var avgZ:Number;
		public var impactX:Number;
		public var impactY:Number;
		public var impactZ:Number;
		public var impactTime:Number;
		public var impactHints:Number;

		public var x_normal:Number;
		public var y_normal:Number;
		public var z_normal:Number;
		public var impactX_normal:Number;
		public var impactY_normal:Number;
		public var impactZ_normal:Number;

		public var angle:Number;
		public var angle2:Number;
		public var orientation:Number;
		public var ro_angle:Number;
		public var ro_angle2:Number;

		private static var HALF_RANGE:int=2048;
		public static var NORTH:int=0;
		public static var EAST:int=1;
		public static var WEST:int=2;
		public static var SOUTH:int=3;

		public function Accelerometer()
		{
		}

		public function calc():void
		{
			impactX_normal=impactX - HALF_RANGE;
			impactY_normal=impactY - HALF_RANGE;
			impactZ_normal=impactZ - HALF_RANGE;

			angle=Math.atan2(-1 * getG(avgZ), -1 * getG(avgX));
			angle2=Math.atan2(-1 * getG(avgZ), getG(avgY));
			orientation=getOrientation(angle);
		}

		public static function getG(raw:Number):Number
		{
			return raw * 0.0024489559928062587 - 5;
		}

		private static function getOrientation(angle:Number):Number
		{
			if ((angle >= (-0.75 * Math.PI)) && (angle < (-0.25 * Math.PI)))
				return NORTH;
			if ((angle >= (-0.25 * Math.PI)) && (angle < (0.25 * Math.PI)))
				return EAST;
			if ((angle >= (0.25 * Math.PI)) && (angle < (0.75 * Math.PI)))
				return SOUTH;
			if ((angle >= (0.75 * Math.PI)) || (angle < (-0.75 * Math.PI)))
				return WEST;

			return -1;
		}
	}
}